# coding: utf-8

"""
    SciCat backend API

    This is the API for the SciCat Backend

    The version of the OpenAPI document: api/v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from scicat_sdk_pydantic.models.update_dataset_dto import UpdateDatasetDto
from scicat_sdk_pydantic.models.update_derived_dataset_obsolete_dto import UpdateDerivedDatasetObsoleteDto
from scicat_sdk_pydantic.models.update_raw_dataset_obsolete_dto import UpdateRawDatasetObsoleteDto
from typing import Union, Any, List, TYPE_CHECKING
from pydantic import StrictStr, Field

DATASETSCONTROLLERFINDBYIDANDREPLACEREQUEST_ANY_OF_SCHEMAS = ["UpdateDatasetDto", "UpdateDerivedDatasetObsoleteDto", "UpdateRawDatasetObsoleteDto"]

class DatasetsControllerFindByIdAndReplaceRequest(BaseModel):
    """
    DatasetsControllerFindByIdAndReplaceRequest
    """

    # data type: UpdateRawDatasetObsoleteDto
    anyof_schema_1_validator: Optional[UpdateRawDatasetObsoleteDto] = None
    # data type: UpdateDerivedDatasetObsoleteDto
    anyof_schema_2_validator: Optional[UpdateDerivedDatasetObsoleteDto] = None
    # data type: UpdateDatasetDto
    anyof_schema_3_validator: Optional[UpdateDatasetDto] = None
    if TYPE_CHECKING:
        actual_instance: Union[UpdateDatasetDto, UpdateDerivedDatasetObsoleteDto, UpdateRawDatasetObsoleteDto]
    else:
        actual_instance: Any
    any_of_schemas: List[str] = Field(DATASETSCONTROLLERFINDBYIDANDREPLACEREQUEST_ANY_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        instance = DatasetsControllerFindByIdAndReplaceRequest.construct()
        error_messages = []
        # validate data type: UpdateRawDatasetObsoleteDto
        if not isinstance(v, UpdateRawDatasetObsoleteDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UpdateRawDatasetObsoleteDto`")
        else:
            return v

        # validate data type: UpdateDerivedDatasetObsoleteDto
        if not isinstance(v, UpdateDerivedDatasetObsoleteDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UpdateDerivedDatasetObsoleteDto`")
        else:
            return v

        # validate data type: UpdateDatasetDto
        if not isinstance(v, UpdateDatasetDto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UpdateDatasetDto`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when setting the actual_instance in DatasetsControllerFindByIdAndReplaceRequest with anyOf schemas: UpdateDatasetDto, UpdateDerivedDatasetObsoleteDto, UpdateRawDatasetObsoleteDto. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> DatasetsControllerFindByIdAndReplaceRequest:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> DatasetsControllerFindByIdAndReplaceRequest:
        """Returns the object represented by the json string"""
        instance = DatasetsControllerFindByIdAndReplaceRequest.construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[UpdateRawDatasetObsoleteDto] = None
        try:
            instance.actual_instance = UpdateRawDatasetObsoleteDto.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[UpdateDerivedDatasetObsoleteDto] = None
        try:
            instance.actual_instance = UpdateDerivedDatasetObsoleteDto.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[UpdateDatasetDto] = None
        try:
            instance.actual_instance = UpdateDatasetDto.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into DatasetsControllerFindByIdAndReplaceRequest with anyOf schemas: UpdateDatasetDto, UpdateDerivedDatasetObsoleteDto, UpdateRawDatasetObsoleteDto. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())


